local sys = require"sys"

local pid = sys.pid()
local fdi, fdo = sys.handle(), sys.handle()
assert(fdi:pipe(fdo))
	
-- Timer
local timer = murgaLua.createFltkTimer()

function on_timer()
	print(pid)
	result, err = fdi:read()
	print("Hello")
	if (err == nil) then
		print("Subprocess output: ", result)
	else
		print("Process : " .. tostring(pid) .. " has ended?")
	end
	io.flush()
	timer:doWait(0.5)
end

timer:callback(on_timer)

-- Subprocess
print(pid)
local sleep_msec = 1000
local subprocess = [[
	murgaLua.sleep(]] .. sleep_msec .. [[)
	sys.stdout:write"Step 1."
	murgaLua.sleep(]] .. sleep_msec .. [[)
	sys.stdout:write"Step 2."
	murgaLua.sleep(]] .. sleep_msec .. [[)
	sys.stdout:write"Exited normally."
]]
print("Subprocess sleep:", sleep_msec)

local args = {"-e", subprocess}
if not sys.spawn(murgaLua_ExePath, args, pid, nil, fdo, nil) then
	error(errorMessage)
end
fdo:close()

print(fdi:read())

on_timer()

window = fltk:Fl_Window(100, 100, "PID test");
window:show()
Fl:run()
