#include "fltk.cxx"

#define init_lua_fltk_State _init_lua_fltk_State
#include "bind-fltk.cxx"
#undef init_lua_fltk_State



static lua_State * S;

void lua_fltk_widget_callback(Fl_Widget * w, void * udata)
{
  lua_settop(S, 0);
  lua_getref(S, (int) udata);
  lua_pushnumber(S, 2);
  lua_gettable(S, 1);
  lua_pushnumber(S, 1);
  lua_gettable(S, 1);
  lua_call(S, 1, 0);
}

void lua_fltk_fl_callback(void * udata)
{
  lua_settop(S, 0);
  lua_getref(S, (int) udata);
  lua_pushnumber(S, 2);
  lua_gettable(S, 1);
  lua_pushnumber(S, 1);
  lua_gettable(S, 1);
  lua_call(S, 1, 0);
}


int lua_fltk__Fl_Widget__callback(lua_State * __S__)
{
  int nparam = lua_gettop(__S__);
  int __ERROR__ = 0;
	
  Fl_Widget * self;
  self = ( class Fl_Widget * )lua_to_Fl_Widget(__S__, 1, &__ERROR__);
  
  if (__ERROR__)
    return 0;

  if (lua_isnil(__S__, 2))
    ;//self->callback(0); // ??
  else {
    lua_settop(__S__, 2);
    lua_newtable(__S__);

    lua_pushnumber(__S__, 1);
    lua_pushvalue(__S__, 1);
    lua_settable(__S__, 3);

    lua_pushnumber(__S__, 2);
    lua_pushvalue(__S__, 2);
    lua_settable(__S__, 3);

    int ref = lua_ref(__S__, 3);
    S = __S__;
    self->callback(lua_fltk_widget_callback, (void *) ref);
  }

  return 0;
}

int lua_fltk__Fl_Menu_Item__callback(lua_State * __S__)
{
  int nparam = lua_gettop(__S__);
  int __ERROR__ = 0;
	
  Fl_Menu_Item * self;
  self = ( class Fl_Menu_Item * )lua_to_Fl_Menu_Item(__S__, 1, &__ERROR__);
  
  if (__ERROR__)
    return 0;

  if (lua_isnil(__S__, 2))
    ;//self->callback(0); // ??
  else {
    lua_settop(__S__, 2);
    lua_newtable(__S__);

    lua_pushnumber(__S__, 1);
    lua_pushvalue(__S__, 1);
    lua_settable(__S__, 3);

    lua_pushnumber(__S__, 2);
    lua_pushvalue(__S__, 2);
    lua_settable(__S__, 3);

    int ref = lua_ref(__S__, 3);
    S = __S__;
    self->callback((Fl_Callback *) lua_fltk_widget_callback, (void *) ref);
  }

  return 0;
}

int lua_fltk__Fl__add_idle__callback(lua_State * __S__)
{
  int nparam = lua_gettop(__S__);
  int __ERROR__ = 0;
  if (lua_istable(__S__, 1)) { lua_remove(__S__, 1); nparam--; }
  {
    lua_settop(__S__, 2);
    lua_newtable(__S__);

    lua_pushnumber(__S__, 1);
    lua_pushvalue(__S__, 1);
    lua_settable(__S__, 3);

    lua_pushnumber(__S__, 2);
    lua_pushvalue(__S__, 1);
    lua_settable(__S__, 3);

    int ref = lua_ref(__S__, 3);
    S = __S__;
    Fl::add_idle(lua_fltk_fl_callback, (void *) ref);
    lua_pushnumber(__S__, ref);
	return 1;
  }

  return 0;
}

int lua_fltk__Fl__remove_idle__callback(lua_State * __S__)
{
  int nparam = lua_gettop(__S__);
  int __ERROR__ = 0;
  if (lua_istable(__S__, 1)) { lua_remove(__S__, 1); nparam--; }
  {
    int ref = (int) lua_tonumber(__S__, 1);
    Fl::remove_idle(lua_fltk_fl_callback, (void *) ref);
  }
  return 0;
}

int lua_fltk__Fl__has_idle__callback(lua_State * __S__)
{
  int nparam = lua_gettop(__S__);
  int __ERROR__ = 0;
  if (lua_istable(__S__, 1)) { lua_remove(__S__, 1); nparam--; }
  {
    int ref = (int) lua_tonumber(__S__, 1);
    lua_pushnumber(__S__, Fl::has_idle(lua_fltk_fl_callback, (void *) ref));
	return 1;
  }

  return 0;
}

/* void Fl::add_idle(void ( * cb)(void * ), void * =0) */
/* void Fl::remove_idle(void ( * cb)(void * ), void * =0) */
/* int Fl::has_idle(void ( * cb)(void * ), void * =0) */



int init_lua_fltk_State(lua_State * _S)
{
  S = _S;

  int BS = !_init_lua_fltk_State(S);

  lua_pushcclosure(S, lua_fltk__Fl_Widget__callback, 0);
  lua_setglobal(S, "fl_callback_widget");
  luaL_dostring(S, 
"bind_lua_addtovtable(Fl_Widget, 'callback', fl_callback_widget) \n"
"fl_callback_widget = nil \n");

  lua_pushcclosure(S, lua_fltk__Fl_Menu_Item__callback, 0);
  lua_setglobal(S, "fl_callback_menu");
  luaL_dostring(S, 
"bind_lua_addtovtable(Fl_Menu_Item, 'callback', fl_callback_menu) \n"
"fl_callback_menu = nil \n");

  lua_pushcclosure(S, lua_fltk__Fl__add_idle__callback, 0);
  lua_setglobal(S, "fl_callback_add_idle");
  luaL_dostring(S, 
"bind_lua_addtovtable(Fl, 'add_idle', fl_callback_add_idle) \n"
"fl_callback_add_idle = nil \n");

  lua_pushcclosure(S, lua_fltk__Fl__remove_idle__callback, 0);
  lua_setglobal(S, "fl_callback_remove_idle");
  luaL_dostring(S, 
"bind_lua_addtovtable(Fl, 'remove_idle', fl_callback_remove_idle) \n"
"fl_callback_remove_idle = nil \n");

  lua_pushcclosure(S, lua_fltk__Fl__has_idle__callback, 0);
  lua_setglobal(S, "fl_callback_has_idle");
  luaL_dostring(S, 
"bind_lua_addtovtable(Fl, 'has_idle', fl_callback_has_idle) \n"
"fl_callback_has_idle = nil \n");

  return BS? 0 : -1;
}

